# -----------------------------------------------------------------------------
# $Id: LocalChannelManager.pm 542 2004-09-11 08:26:06Z topia $
# -----------------------------------------------------------------------------
# Υ饹Tiarraʥͥޤ
# ƥ饤ȤˡΥ饤ȤäƤTiarraͥ
# `tiarra-local-channels'Ȥƻޤ
# ϥͥ̾Ǥ
# -----------------------------------------------------------------------------
# Ȥ:
#
# -----------------------------------------------------------------------------
package LocalChannelManager;
use strict;
use warnings;
use Carp;
use Tiarra::SharedMixin;
our $_shared_instance;

sub _new {
    my $class = shift;
    my $this = {
	registered => {}, # {ͥ̾ => [ȥԥå(ʸ), ϥɥ()]}
    };
    bless $this => $class;
}

sub register {
    # Name => ͥ̾
    # Topic => ȥԥå
    # Handler => ϥɥ; $handler->($client, $msg)Τ褦˸ƤФ롣
    my ($class_or_this, %args) = @_;
    my $this = $class_or_this->_this;

    foreach my $arg (qw/Name Topic Handler/) {
	if (!defined $args{$arg}) {
	    croak "LocalChannelManager->register, Arg{Name} is undef.\n";
	}
    }
    if (ref($args{Handler}) ne 'CODE') {
	croak "LocalChannelManager->register, Arg{Handler} is not a function.\n";
    }

    if (defined $this->{registered}{$args{Name}}) {
	croak "LocalChannelManager->register, channel `$args{Name}' is already registered.\n";
    }

    $this->{registered}{$args{Name}} = [@args{'Topic', 'Handler'}];
    $this;
}

sub unregister {
    my ($class_or_this, $channel) = @_;
    my $this = $class_or_this->_this;

    delete $this->{registered}{$channel};
    $this;
}

sub registered_p {
    my ($class_or_this, $channel) = @_;
    my $this = $class_or_this->_this;

    defined $this->{registered}{$channel};
}

sub message_arrived {
    # IRCMessageޤundef֤
    my ($class_or_this, $msg, $sender) = @_;
    my $this = $class_or_this->_this;

    my $method = '_'.$msg->command;
    if ($this->can($method)) {
	$this->$method($msg, $sender);
    }
    else {
	$msg;
    }
}

sub _JOIN {
    my ($this, $msg, $sender) = @_;

    # ͥ̾ΥꥹȤ顢Tiarraͥȴ롣
    my @new_list;
    foreach my $ch_name (split m/,/, $msg->param(0)) {
	if ($this->registered_p($ch_name)) {
	    my ($topic, $handler) = @{$this->{registered}{$ch_name}};

	    # Υ饤Ȥ`tiarra-local-channels'äƤ뤫
	    my $list = $sender->remark('tiarra-local-channels');
	    if (!defined $list) {
		$list = [];
		$sender->remark('tiarra-local-channels', $list);
	    }
	    if (!{map {$_ => 1} @$list}->{$ch_name}) {
		# äƤʤΤJOINԤ
		push @$list, $ch_name;

		my $local_nick = RunLoop->shared->current_nick;
		# ޤJOIN
		$sender->send_message(
		    IRCMessage->new(
			Prefix => $sender->fullname,
			Command => 'JOIN',
			Param => $ch_name));
		# RPL_TOPIC()
		if ($topic ne '') {
		    $sender->send_message(
			IRCMessage->new(
			    Prefix => 'Tiarra',
			    Command => '332',
			    Params => [
				$local_nick,
				$ch_name,
				$topic,
			    ]));
		}
		# RPL_NAMREPLYܿͤ
		$sender->send_message(
		    IRCMessage->new(
			Prefix => 'Tiarra',
			Command => '353',
			Params => [$local_nick,
				   '=',
				   $ch_name,
				   $local_nick]));
		# RPL_ENOFNAMES
		$sender->send_message(
		    IRCMessage->new(
			Prefix => 'Tiarra',
			Command => '366',
			Params => [$local_nick,
				   $ch_name,
				   'End of NAMES list']));
	    }
	}
	else {
	    push @new_list, $ch_name;
	}
    }
    $msg->param(0, join(',', @new_list));
    
    $msg;
}

1;
